from sqlalchemy import Column, Integer, String, Boolean, DateTime, func
from sqlalchemy.sql import expression

from app.db.session import Base


class Todo(Base):
    """Todo model for database representation"""

    __tablename__ = "todos"

    id = Column(Integer, primary_key=True, index=True)
    title = Column(String, nullable=False)
    description = Column(String, nullable=True)
    completed = Column(Boolean, server_default=expression.false(), nullable=False)
    created_at = Column(DateTime(timezone=True), server_default=func.now())
    updated_at = Column(
        DateTime(timezone=True), server_default=func.now(), onupdate=func.now()
    )
